function YY = newsteady_solver(x)

load calibration; load options; load guess; load reforms;  load policyTargets;

c_SS            = x(1);
k_SS            = x(2);
w_SS            = x(3);
zc_SS           = x(4);
q_SS            = x(5);
l_SS            = x(6);
N_SS            = x(7);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (ubI==1);     rrRateP       = rrRateFlex;       end
% if (fcI==1);     fcRate        = fcRateFlex;       end
% if (pmrI==1);    feregrateP    = feregtargetFlex;  end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 
 
elasticity_SS       =(1 + sigmaMuP*N_SS);
markup_SS           = elasticity_SS/(elasticity_SS - 1);
rpD_SS              =(exp(-0.5*(NbarP-N_SS)/(sigmaMuP*NbarP*N_SS)));
ubP                 = rrRateP*w_SS/rpD_SS; 
% ubP                 = 0;
tau_ub_SS          = -(ubP/hpP);

% if (fcI==0);
%     load steadyInitial; fcP = fc_SSinit;
% else
%     fcP             = fcRate*w_SS;
% end
fcP             = 0;

z_SS                = 1;
% mc_SS               = rpD_SS/markup_SS;
tau_SS               = markup_SS - 1;
mc_SS                = rpD_SS/markup_SS*(1 + tau_SS);
Ne_SS               = (deltafP/(1-deltafP))*N_SS;
rho_SS              = cdf('lognormal', zc_SS , meanziP , stdziP);
zavInt_SS           = (-1/2*piP^(1/2)*exp(1/2*(2*meanziP+stdziP^2*shapeP)*shapeP/(1-2*alphaP+alphaP^2))*(erf(1/2*2^(1/2)/stdziP*(-log(zc_SS)+log(zc_SS)*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/(-1+alphaP))-erf(1/2*2^(1/2)*(-10000000000+10000000000*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/stdziP/(-1+alphaP)))*exp(-shapeP*meanziP*alphaP/(-1+alphaP)^2)/piP^(1/2))/(1-rho_SS);
zav_SS              = zavInt_SS^(1/exponenpfP);
u_SS                = 1 - l_SS;
m_SS                = (l_SS - (1-lambdaP)*(1-deltafP)*(1-rho_SS)*l_SS)/((1-lambdaP)*(1-deltafP)*(1-rho_SS));
v_SS                = m_SS/q_SS;
s_SS                = m_SS/u_SS;
yn_SS               = z_SS*(zav_SS^shapeP)*(k_SS^alphaP)*(l_SS^(1-alphaP));
mpl_SS              = (1 - alphaP)*mc_SS*yn_SS/l_SS;
mplzc_SS            = mpl_SS*((zc_SS/zav_SS)^exponenpfP);
wzc_SS              = w_SS - etaP*(mpl_SS - mplzc_SS); 
% phi_SS              = mpl_SS + vcP/q_SS - (etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP) + (etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP));
phi_SS               = mpl_SS + vcP/q_SS - (etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP*(1 + tau_ub_SS)) + (etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP));
mpk_SS              = alphaP*mc_SS*yn_SS/k_SS;
ik_SS               = deltakP*k_SS;                     
kfirm_SS            = k_SS/N_SS;
lfirm_SS            = l_SS/N_SS;
% cm_SS               = c_SS - hpP*(1-l_SS);
cm_SS                = c_SS - hpP*(1 + tau_ub_SS)*(1-l_SS);

load steadyInitial yn_SSinit
fetechP              = fetechtarget*yn_SSinit;
% fr_SS                = feregrateP*yn_SS;
% if (pmrI==0); load steadyInitial; fr_SS = fr_SSinit; end
fr_SS                = 0;

fe_SS                = fetechP + fr_SS;
y_SS                 = Ne_SS*fe_SS + cm_SS + ik_SS + vcP*v_SS + rho_SS*l_SS*fcP/(1-rho_SS);
yfirm_SS             = (1/rpD_SS)*y_SS/N_SS;
vfirm_SS             = (v_SS - Ne_SS*lfirm_SS/q_SS)/(N_SS + Ne_SS);
% d_SS                 = rpD_SS*yfirm_SS - mpk_SS*kfirm_SS - vcP*vfirm_SS - rho_SS*lfirm_SS*fcP/(1-rho_SS)  - lfirm_SS*w_SS;
profitsub_SS         = (1/(2*sigmaMuP*N_SS))*rpD_SS*yfirm_SS; 
d_SS                 = rpD_SS*yfirm_SS - mpk_SS*kfirm_SS - vcP*vfirm_SS - rho_SS*lfirm_SS*fcP/(1-rho_SS)  - lfirm_SS*w_SS + profitsub_SS;
e_SS                 = fe_SS + vcP*(lfirm_SS/q_SS + vfirm_SS);
firing_SS            = etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP;

   
YY         =  [ - yn_SS         + yfirm_SS*N_SS;
                - vcP           + q_SS*( - mpl_SS*((zc_SS/zav_SS)^exponenpfP) + wzc_SS - fcP);
                - vcP/q_SS      + betaP*(1-lambdaP)*(1-deltafP)*( (1 - rho_SS)*phi_SS - rho_SS*fcP);                  
                - 1             + betaP*(mpk_SS  + 1 - deltakP);
                - w_SS          + etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP*(1 + tau_ub_SS)) + firing_SS; 
                - m_SS          + (chiP*(v_SS^(1-epsP))*(u_SS^(epsP)));
                - e_SS          + (((1-deltafP)*betaP)/(1 - (1-deltafP)*betaP))*d_SS;];
            
% - w_SS          + etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP) + firing_SS